VERSION 5.00
Begin VB.Form frmMain 
   BackColor       =   &H00A0D0D0&
   Caption         =   "LineWatcher"
   ClientHeight    =   2955
   ClientLeft      =   60
   ClientTop       =   630
   ClientWidth     =   5625
   ForeColor       =   &H00000000&
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   2955
   ScaleWidth      =   5625
   StartUpPosition =   2  'CenterScreen
   Begin VB.ComboBox cboConnections 
      Height          =   315
      Left            =   1035
      Sorted          =   -1  'True
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   90
      Width           =   3255
   End
   Begin VB.TextBox txtLog 
      ForeColor       =   &H000000FF&
      Height          =   975
      Left            =   45
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   6
      Top             =   945
      Width           =   5520
   End
   Begin VB.CommandButton cmdExit 
      BackColor       =   &H00C0D0D0&
      Caption         =   "E&xit"
      Height          =   420
      Left            =   4365
      Style           =   1  'Graphical
      TabIndex        =   2
      Top             =   45
      Width           =   1185
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   10000
      Left            =   2475
      Top             =   2025
   End
   Begin VB.TextBox txtStatus 
      ForeColor       =   &H80000007&
      Height          =   975
      Left            =   45
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   4
      Top             =   1935
      Width           =   5520
   End
   Begin VB.CommandButton cmdAction 
      BackColor       =   &H0080FFFF&
      Caption         =   "?"
      Height          =   405
      Left            =   4365
      Style           =   1  'Graphical
      TabIndex        =   3
      Top             =   495
      Width           =   1200
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      BackStyle       =   0  'Transparent
      Caption         =   "Status:"
      Height          =   285
      Index           =   1
      Left            =   0
      TabIndex        =   7
      Top             =   585
      Width           =   915
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      BackStyle       =   0  'Transparent
      Caption         =   "&Connect to:"
      Height          =   285
      Index           =   0
      Left            =   0
      TabIndex        =   0
      Top             =   135
      Width           =   915
   End
   Begin VB.Label lblStatus 
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   1  'Fixed Single
      Height          =   285
      Left            =   1035
      TabIndex        =   5
      Top             =   540
      Width           =   3255
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFilePref 
         Caption         =   "&Preferences..."
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About "
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' RICHARD GOUTORBE ( rghome@reseau.org http://www.reseau.org/rg/ ) holds the copyright to all code in this document.
' You are granted a license to use this code under the following conditions:
' - You are free to modify the code in any way you see fit.
' - You are free to redistribute the code FOR NON-PROFIT PURPOSE provided that
'     1) appropriate credit is given to Richard Goutorbe, and
'     2) you do not charge any kind of fee for the code without the written permission of Richard Goutorbe.
' You are free to redistibute a binary compiled version of the code for any purpose, profit or non-profit.
' If you distribute the code in this form, you must give appropriate credit to Richard Goutorbe.
' PUBLISHING THE CODE ON OTHER WEB SITES, OR POSTING THE CODE ON OTHER WEB SITES FOR PUBLICATION WITHOUT THE WRITTEN PERMISSION OF RICHARD GOUTORBE, IS STRICTLY PROHIBITED.
Option Explicit

Private mInet_obj As CNetConn
Private mInitialized_bool As Boolean
Private mPref_obj As CPref
Private mChildForms_bool(1) As Boolean ' 0=frmAbout loaded, 1=frmPref

Private Enum CONN_STATUS
    STATUS_UNDEF = 0
    STATUS_OFFLINE = 1
    STATUS_ONLINE = 2
    STATUS_BUSY = 3
End Enum

Private Sub Form_Initialize()
    Set mInet_obj = New CNetConn
    Set mPref_obj = New CPref
    mInitialized_bool = False
End Sub

Private Sub Form_Load()
    
    Me.Caption = App.Title & " v" & App.Major & "." & App.Minor & "." & App.Revision
    ConnectionStatus = STATUS_UNDEF
    
    mPref_obj.LoadPref
    
    WriteLog App.Title & " version " & App.Major & "." & App.Minor & "." & App.Revision & " Begin", vbLogEventTypeWarning
    
    If (Len(mPref_obj.RASConnection) = 0) Then
        MsgBox "Installation notes:" & vbCrLf _
            & "1) Open the Internet Options tool in Window's control pannel," & vbCrLf _
            & "     select the 'Connections' tab, and click 'Never dial a connection'" & vbCrLf _
            & "     to allow LineWatcher to dial your ISP when your connection gets dropped." & vbCrLf _
            & "2) Click the Ok button below and select your default remote access service" & vbCrLf _
            & "     in the 'connect to' drop-down list" & vbCrLf _
            & "3) Restart this program." _
            , vbInformation, App.Title
        mnuFilePref_Click
        Unload Me
    Else
        
        If (mPref_obj.AutoConnectDelay > 0) Then
            Timer1.Enabled = True
            Timer1.Interval = mPref_obj.AutoConnectDelay * 1000
        Else
            Timer1.Enabled = False
        End If
        
        With mInet_obj
            .PingEnabled = (Len(mPref_obj.PingHost) > 0) ' disable ping if no ping host defined
            If (.PingEnabled) Then
                .PingHostName = mPref_obj.PingHost
                WriteTrace "(ping " & .PingHostName & " every " & mPref_obj.PingDelay & " s)"
            Else
                WriteTrace "(ping is disabled)"
            End If
        End With
        
        'get list of DUNS on the system and select active one
        Load_ListRas cboConnections
    End If
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    If (UnloadMode = vbFormControlMenu Or UnloadMode = vbFormCode) Then
        If (ConnectionStatus = STATUS_BUSY) Then
            Dim answer As VbMsgBoxResult
            answer = MsgBox("Warning: network operation in progress" & vbCrLf _
                & "Your system may become instable if you quit now" & vbCrLf _
                & "Do you really want to exit ?" _
                , vbQuestion + vbYesNo, App.Title)
            If (answer = vbNo) Then
                Cancel = 1
            End If
        End If
    End If
End Sub

Private Sub Form_Paint()
    If (Not mInitialized_bool) Then
        ' first paint only
        Dim connected_bool As Boolean
    
        WriteTrace "Checking connection status..."
        ConnectionStatus = STATUS_BUSY ' operation in progress...
        connected_bool = mInet_obj.IsConnected()
        ConnectionStatus = IIf(connected_bool, STATUS_ONLINE, STATUS_OFFLINE)
        If (connected_bool) Then
            WriteTrace "(already online)"
        Else
            WriteTrace "Offline"
            If (mPref_obj.AutoConnectDelay > 0) Then
                WriteTrace "Autoconnection in " & mPref_obj.AutoConnectDelay & " s"
            Else
                WriteTrace "Autoconnection is off; click Connect button."
            End If
        End If
        'Timer1.Enabled = True ' timer will try to connect if we are offline
        mInitialized_bool = True
    End If
End Sub

Private Sub Form_Terminate()
    Set mInet_obj = Nothing
    Set mPref_obj = Nothing
End Sub

Private Sub Form_Unload(Cancel As Integer)
    WriteLog App.Title & " End.", vbLogEventTypeWarning
End Sub

Private Sub mnuFileExit_Click()
    cmdExit_Click
End Sub

Private Sub cmdExit_Click()
    On Error Resume Next
    Unload Me
    On Error GoTo 0
End Sub

Private Sub cmdAction_Click()
    Timer1.Enabled = False ' disable auto connect
    If (ConnectionStatus = STATUS_OFFLINE) Then
        Dim connected_bool As Boolean
        connected_bool = Open_connection()
        Timer1.Enabled = True ' timer will retry to reconnect if 1st connection try failed
    ElseIf (ConnectionStatus = STATUS_ONLINE) Then
        Close_connection "Connection terminated by user"
    End If
End Sub

Private Sub mnuFilePref_Click()
    mChildForms_bool(1) = True
    mPref_obj.Show
    mChildForms_bool(1) = False
End Sub

Private Sub mnuHelpAbout_Click()
    mChildForms_bool(0) = True
    
    Dim frmAbout_obj As frmAbout
    Set frmAbout_obj = New frmAbout
    frmAbout.Show vbModal
    Set frmAbout_obj = Nothing
    
    mChildForms_bool(0) = False
End Sub

Private Sub Timer1_Timer()
    ' test if some child form is loaded
    Dim childform_bool As Boolean
    Dim idx As Integer
    For idx = 0 To UBound(mChildForms_bool)
        childform_bool = mChildForms_bool(idx)
        If (childform_bool) Then
            Exit For
        End If
    Next
    
    ' ignore timer event if some child form is loaded
    If (Not childform_bool) Then
        Dim connected_bool As Boolean
        
        lblStatus.Caption = Time
        Timer1.Enabled = False
        Timer1.Interval = mPref_obj.PingDelay * 1000 ' set normal delay after 1st try
        
        ConnectionStatus = STATUS_BUSY
        connected_bool = mInet_obj.IsConnected()
        If (Not connected_bool) Then
            ' connection was lost
            Close_connection "Connection lost" ' make sure it is really terminated
            connected_bool = Open_connection() ' try to reopen connection
        Else
            ConnectionStatus = STATUS_ONLINE
        End If
        
        Timer1.Enabled = True
    End If
    DoEvents
End Sub

' Implementation ----------------------------------------------------------------------------

Public Sub Load_ListRas(trgList_obj As ComboBox)
    Dim psDuns() As String
    Dim piMax As Integer
    Dim idx As Integer
    
    'get list of DUNS on the system
    mInet_obj.ListRAS psDuns
    trgList_obj.Clear
    
    'put list in the listbox
    piMax = -1
    On Error Resume Next
    piMax = UBound(psDuns())
    On Error GoTo 0
    For idx = 0 To piMax
        trgList_obj.AddItem psDuns(idx)
    Next idx
    
    ' select active RAS in combo
    If (trgList_obj.ListCount > 0) Then
        trgList_obj.ListIndex = 0 ' select first entry by default
        With trgList_obj
            For idx = 0 To .ListCount - 1
                If (.List(idx) = mPref_obj.RASConnection) Then
                    .ListIndex = idx
                    Exit For
                End If
            Next
        End With
    End If
  End Sub


' Return True if connection is open
Private Function Open_connection() As Boolean
    Dim connected_bool As Boolean: connected_bool = False
    Dim plResult As Long
    
    With cboConnections
        If .ListIndex = -1 Then
            MsgBox "Please select a Remote Access Service from the list", vbOKOnly + vbExclamation, App.Title
        Else
            ConnectionStatus = STATUS_BUSY ' operation in progress...
            WriteTrace "Connecting  to " & .List(.ListIndex)
            plResult = mInet_obj.Connect(Me.hwnd, .List(.ListIndex))
            If plResult = 0& Or plResult = -1 Then ' connected or already connected
                connected_bool = mInet_obj.IsConnected()
            End If
            If (Not connected_bool) Then
                Call WriteTrace("Error " & plResult & " attempting to connect to " & .List(.ListIndex))
            End If
            ConnectionStatus = IIf(connected_bool, STATUS_ONLINE, STATUS_OFFLINE)
        End If
    End With
    Open_connection = connected_bool
End Function

Private Sub Close_connection(reason_str As String)
    mInet_obj.HangUp
    Call WriteTrace(reason_str)
    ConnectionStatus = STATUS_OFFLINE
End Sub


Private Property Get ConnectionStatus() As CONN_STATUS
    ConnectionStatus = CInt(Val(cmdAction.Tag))
End Property

Private Property Let ConnectionStatus(new_status As CONN_STATUS)
    Static connection_count As Long
    Static online_int As CONN_STATUS
    
    If (new_status = STATUS_ONLINE And (online_int = STATUS_OFFLINE Or online_int = STATUS_UNDEF)) Then
        connection_count = connection_count + 1
        WriteTrace "Connection #" & connection_count & " started at " & Time, txtLog
        online_int = STATUS_ONLINE
        txtLog.ForeColor = &H8000& 'dark green
    ElseIf (new_status = STATUS_OFFLINE And online_int = STATUS_ONLINE) Then
        WriteTrace "Connection #" & connection_count & "  lost at " & Time, txtLog
        online_int = STATUS_OFFLINE
        txtLog.ForeColor = &HFF& 'red
    End If
    
    cmdAction.Tag = CStr(new_status)
    cmdAction.Enabled = True
    lblStatus.Caption = Time & " "
        
    Select Case new_status
        Case STATUS_BUSY:
            cmdAction.Caption = "Busy..."
            cmdAction.BackColor = vbYellow
            lblStatus.Caption = lblStatus.Caption & "Busy..."
            cmdAction.Enabled = False
        Case STATUS_ONLINE:
            cmdAction.Caption = "&Hangup"
            cmdAction.BackColor = vbGreen
            lblStatus.Caption = lblStatus.Caption & "Connected"
        Case STATUS_OFFLINE:
            cmdAction.Caption = "C&onnect"
            cmdAction.BackColor = vbRed
            lblStatus.Caption = lblStatus.Caption & "Not connected"
        Case Else
            ' undefined status
    End Select
    
    DoEvents
End Property


'add supplied text_str to box, log text_str to file
Private Sub WriteTrace(text_str As String, Optional textbox_obj As TextBox = Nothing)
    Const MAX_STATUS_LENGTH = 8 * 1024
    Dim fmt_text_str As String
    fmt_text_str = CStr(Time) & " " & text_str
    
    If (textbox_obj Is Nothing) Then
        Set textbox_obj = txtStatus
    End If
    
    ' log text_str to file
    WriteLog text_str, IIf(textbox_obj Is txtStatus, vbLogEventTypeInformation, vbLogEventTypeWarning)
    
    ' add text_str to box
    With textbox_obj
        .text = .text & fmt_text_str & vbCrLf
        If (Len(.text) > MAX_STATUS_LENGTH) Then
            .text = Right(.text, MAX_STATUS_LENGTH)
        End If
        'scroll text down if necessary
        .SelStart = Len(.text)
        .SelLength = 0
        DoEvents
    End With
End Sub


' EventType: vbLogEventTypeInformation (default), vbLogEventTypeWarning
'Warning:  the LogEvent and StartLogging Methods work only in a compiled DLL. They do not work in the Microsoft Visual Basic IDE.
Private Sub WriteLog(ByVal text As String, Optional ByVal EventType As Long = vbLogEventTypeInformation)
    Static started_bool As Boolean
    
    If (mPref_obj.LogLevel > 0) Then
        If (Not started_bool) Then
            App.StartLogging App.Path & "\" & App.Title & ".log", vbLogToFile
            started_bool = True
        End If
    
        If ((mPref_obj.LogLevel = 1 And EventType = vbLogEventTypeWarning) Or mPref_obj.LogLevel = 2) Then
            App.LogEvent App.Title & " " & CStr(Now) & " " & text, EventType
        End If
    End If
End Sub


